// experSwarm.java

import swarm.Globals; // no # but a ; at the end
import swarm.Selector;
import swarm.defobj.Zone;
import swarm.defobj.ZoneImpl;
import swarm.activity.Activity;
import swarm.activity.ActionGroup;
import swarm.activity.ActionGroupImpl;
import swarm.activity.Schedule;
import swarm.activity.ScheduleImpl;
import swarm.objectbase.Swarm;
import swarm.objectbase.VarProbe;
import swarm.objectbase.MessageProbe;
import swarm.objectbase.EmptyProbeMapImpl;
import swarm.simtoolsgui.GUISwarm;
import swarm.simtoolsgui.GUISwarmImpl;
import swarm.defobj.LispArchiverImpl;
import swarm.collections.Array;
import swarm.collections.ArrayImpl;
import swarm.collections.List;
import swarm.collections.ListImpl;


public class ExperSwarm extends GUISwarmImpl
	{
// declare variables
	public int minStartBudget;
	public int maxStartBudget;
	public int incStartBudget;
	public int setStartBudget;
	public ListImpl listOfAllSpending;
	public float averageSpending;
	public ModelSwarm modelSwarm;

// constructor for ExperSwarm
	public ExperSwarm(Zone aZone)
		{
		super(aZone);
		EmptyProbeMapImpl experProbeMap=new EmptyProbeMapImpl(getZone(),getClass());
		experProbeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass
			("minStartBudget",getClass()));
		experProbeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass
			("maxStartBudget",getClass()));
		experProbeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass
			("incStartBudget",getClass()));
		Globals.env.probeLibrary.setProbeMap$For(experProbeMap,getClass());
		}
// build objects for experSwarm
	public Object buildObjects()
		{
		super.buildObjects();

// create probe displays
    	Globals.env.createArchivedProbeDisplay(this, "experSwarm");
// Allow the user to alter experiment parameters
  		getControlPanel().setStateStopped();
		
		return this;
		}
// run the experiment
	public Object run()
		{
		LispArchiverImpl outfile;
		SimulationData simLoop;
		LispArchiverImpl archiver;
		swarm.collections.ListIndex i=null;
		int sum=0;
		Integer spendingElement;

	// start running the simulation: for each possible starting budget
		for (setStartBudget=minStartBudget;
				setStartBudget<=maxStartBudget;
					setStartBudget+=incStartBudget)
			{
			System.out.println("This round, startBudget is "+setStartBudget);
		// create setup file for ModelSwarm
			simLoop=new SimulationData();
			simLoop.initPara(setStartBudget);
			outfile=new LispArchiverImpl(this,"loop.scm");
			outfile.putShallow$object("modelSwarm",simLoop);
			outfile.sync();
		// create listOfAllSpending
			listOfAllSpending=new ListImpl(getZone());
		// load the data for the modelSwarm (and create it)
			archiver=new LispArchiverImpl(getZone(),"parameters.scm");
			modelSwarm=(ModelSwarm)archiver.getWithZone$key(getZone(),"modelSwarm");
			archiver.drop();
		// load simulation data, which can override some of the parameters
		// just loaded for the modelSwarm
			archiver=new LispArchiverImpl(getZone(),"loop.scm");
			simLoop=(SimulationData)archiver.getWithZone$key(getZone(),"modelSwarm");
			simLoop.setPara(modelSwarm);
			archiver.drop();
//			simLoop.drop();
			outfile.drop();

			modelSwarm.buildObjects();
			modelSwarm.buildActions();

		// run modelSwarm until it finishes
			while (modelSwarm.checkToStop()==0)
				{
				modelSwarm.marketDay();
				modelSwarm.increaseTime();
				modelSwarm.checkToStop();
				}
		// put values in listOfAllSpending from modelSwarm
			listOfAllSpending=(ListImpl)modelSwarm.getAllSpendings();
		// get average spending to use in graph
			i=listOfAllSpending.listBegin(getZone());
			while ((spendingElement=(Integer) i.next())!=null)
				{
				sum+=spendingElement.intValue();
				}
			averageSpending=sum/listOfAllSpending.getCount();
			System.out.println("average spending: "+averageSpending);

		// MAYBE USE IT WITHIN SELECTOR?????
//			spendingGraph.addPoints(setStartBudget,averageSpending);

			}// end of loop on startBudget
		// end of experiment. draw graph and stop panel
		System.out.println("This is the end of the experiment");
//		spendingGraph.paint();
		getControlPanel().setStateStopped();
		return this;
		}

	public Activity activateIn(Swarm swarmContext)
		{
		super.activateIn(swarmContext);
		return (this.getActivity());
		}

		
	}