// Consumer.java

import swarm.Globals;
import swarm.defobj.Zone;
import swarm.objectbase.SwarmObjectImpl;
import swarm.collections.Array;
import swarm.collections.ArrayImpl;
import swarm.collections.Map;
import swarm.collections.MapImpl;
import swarm.space.Object2dDisplay;
import swarm.space.Object2dDisplayImpl;
import swarm.space.Value2dDisplayImpl;
import swarm.gui.ZoomRasterImpl;
import swarm.gui.ZoomRaster;

public class Consumer extends SwarmObjectImpl
	{
// global variables for the class
	public int myBudget;
	public int myMaxBudget;
	public int myName;
	public int moneySpent;
	public int currentTime;
	public int marketGoer;
	public int positionX;
	public int positionY;
	public MapImpl mapOfSpending;
	public ArrayImpl arrayOfVisits;

// constructor (note that they have no return type)
	public Consumer(Zone aZone,int name,int maxBudget,int startBudget,int goer)
		{
		super(aZone);
		myName=name;
		myBudget=startBudget;
		myMaxBudget=maxBudget;
		marketGoer=goer;
		}

// methods to interact with the raster
	public void setPositionX$Y(int x, int y)
		{
		positionX=x;
		positionY=y;
		}

	public Object drawSelfOn(ZoomRasterImpl raster)
		{
		raster.drawPointX$Y$Color(positionX,positionY,this.getStrategyColor());
		return this;
		}

	public byte getStrategyColor()
		{
		byte color=0;
		if (marketGoer==0)
			{
			color=3;
			}
		else if (marketGoer==1)
			{
			color=1;
		}
		else
			{
			System.out.println("wrong marketGoer value");
			System.exit(0);
			}
		return color;
		}
		
// create the map of spending and the array of visits
	public void createMapOfSpending(Zone aZone)
		{
		mapOfSpending=new MapImpl(aZone);
		}
	public void createArrayOfVisits(Zone aZone,int size)
		{
		arrayOfVisits=new ArrayImpl(aZone,size);
		}

// this methods draws a random number between 0 and
// maxBudget to determine the budget of the consumer
	public int findBudget()
		{
		//take myBudget and add to it a random variable between
		// 0 and maxBudget.
		myBudget+=Globals.env.uniformIntRand.getIntegerWithMin$withMax(0,myMaxBudget);
		return myBudget;
		}
		
// determines randomly whether the consumer goes to the market
	public int goToTheMarket()	// note the () when no arguments
		{
		int k;
		k=Globals.env.uniformIntRand.getIntegerWithMin$withMax(0,1);
		marketGoer=k;
		return k;
		}

// determines randomly how much is spent on the market
	public int spend()
		{
		moneySpent=Globals.env.uniformIntRand.getIntegerWithMin$withMax(0,myBudget);
		return moneySpent;
		}

// calculate remaining budget
	public int calculateRemainingBudget()
		{
		myBudget-=moneySpent;
		return myBudget;
		}


// these methods are used to add elements to the map of spendings,
// and the array of visits, they also take care of casting the int
// values into Integer objects
	public void updateSpending(int key, int value)
		{
		Integer keyObject=new Integer(key);
		Integer valueObject=new Integer(value);
		mapOfSpending.at$insert(keyObject,valueObject);
		}
	public void updateVisits(int offset, int value)
		{
		// note: set the currentTime to offset, which corresponds
		// to modelTime
		currentTime=offset;
		// update arrayOfVisits.
		Integer valueObject=new Integer(value);
		arrayOfVisits.atOffset$put(offset,valueObject);
		}
// pass variables to other classes
	public int getConsumerName()
		{
		return myName;
		}

	public int getBudget()
		{
		return myBudget;
		}

// get value at offset, in arrayOfVisits
// note: the return of a list, etc is an Object, so we need
// to cast it as and Integer when retrieving it
	public int getVisitValue(int offset)
		{
		Integer element;
		element=(Integer) arrayOfVisits.atOffset(offset);
		return element.intValue();
		}

// get value of element at key
	public int getSpendingValue(int key)
		{
		Integer keyObject;
		Integer element;
		keyObject=new Integer(key);
		element=(Integer) mapOfSpending.at(keyObject);
		return element.intValue();
		}

// get visit (for graphs)
	public int getVisit()
		{
		return this.getVisitValue(currentTime);
		}
// getspending (for graphs)
	public int getSpending()
		{
		return this.getSpendingValue(currentTime);
		}
// get positions in space
	public int getPositionX()
		{
		return positionX;
		}
	public int getPositionY()
		{
		return positionY;
		}
	} // end of consumer class